Index: pjproject/main/pjlib/build/pjlib++.vcproj
===================================================================
--- pjproject/main/pjlib/build/pjlib++.vcproj	(revision 36)
+++ pjproject/main/pjlib/build/pjlib++.vcproj	(revision 36)
@@ -0,0 +1,230 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="pjlibpp"
+	SccProjectName=""
+	SccAuxPath=""
+	SccLocalPath=""
+	SccProvider="">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory=".\output\pjlibpp-i386-win32-vc7-release"
+			IntermediateDirectory=".\output\pjlibpp-i386-win32-vc7-release"
+			ConfigurationType="4"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="FALSE"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="2"
+				InlineFunctionExpansion="1"
+				AdditionalIncludeDirectories="../src"
+				PreprocessorDefinitions="NDEBUG;WIN32;_LIB;PJ_WIN32;PJ_M_I386"
+				StringPooling="TRUE"
+				RuntimeLibrary="2"
+				EnableFunctionLevelLinking="TRUE"
+				PrecompiledHeaderFile=".\output\pjlibpp-i386-win32-vc7-release/pjlibpp.pch"
+				AssemblerListingLocation=".\output\pjlibpp-i386-win32-vc7-release/"
+				ObjectFile=".\output\pjlibpp-i386-win32-vc7-release/"
+				ProgramDataBaseFileName=".\output\pjlibpp-i386-win32-vc7-release/"
+				WarningLevel="3"
+				SuppressStartupBanner="TRUE"
+				CompileAs="0"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="../lib/pjlibp_vc6s.lib"
+				SuppressStartupBanner="TRUE"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"
+				PreprocessorDefinitions="NDEBUG"
+				Culture="1033"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory=".\output\pjlibpp-i386-win32-vc7-debug"
+			IntermediateDirectory=".\output\pjlibpp-i386-win32-vc7-debug"
+			ConfigurationType="4"
+			UseOfMFC="0"
+			ATLMinimizesCRunTimeLibraryUsage="FALSE"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="../src"
+				PreprocessorDefinitions="_DEBUG;WIN32;_LIB;PJ_WIN32;PJ_M_I386"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="1"
+				PrecompiledHeaderFile=".\output\pjlibpp-i386-win32-vc7-debug/pjlibpp.pch"
+				AssemblerListingLocation=".\output\pjlibpp-i386-win32-vc7-debug/"
+				ObjectFile=".\output\pjlibpp-i386-win32-vc7-debug/"
+				ProgramDataBaseFileName=".\output\pjlibpp-i386-win32-vc7-debug/"
+				WarningLevel="3"
+				SuppressStartupBanner="TRUE"
+				DebugInformationFormat="4"
+				CompileAs="0"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLibrarianTool"
+				OutputFile="../lib/pjlibp_vc6sd.lib"
+				SuppressStartupBanner="TRUE"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"
+				PreprocessorDefinitions="_DEBUG"
+				Culture="1033"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="Source Files"
+			Filter="cpp;c;cxx;rc;def;r;odl;idl;hpj;bat">
+			<File
+				RelativePath="..\src\pj++\compiletest.cpp">
+				<FileConfiguration
+					Name="Release|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						Optimization="2"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						Optimization="0"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+						BasicRuntimeChecks="3"/>
+				</FileConfiguration>
+			</File>
+			<File
+				RelativePath="..\src\pj++\pj++.cpp">
+				<FileConfiguration
+					Name="Release|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						Optimization="2"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						Optimization="0"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+						BasicRuntimeChecks="3"/>
+				</FileConfiguration>
+			</File>
+			<File
+				RelativePath="..\src\pj++\proactor.cpp">
+				<FileConfiguration
+					Name="Release|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						Optimization="2"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Debug|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						Optimization="0"
+						AdditionalIncludeDirectories=""
+						PreprocessorDefinitions=""
+						BasicRuntimeChecks="3"/>
+				</FileConfiguration>
+			</File>
+		</Filter>
+		<Filter
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl">
+			<File
+				RelativePath="..\src\pj++\hash.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\ioqueue.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\list.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\os.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pjlib++.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\pool.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\proactor.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\scanner.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\sock.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\string.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\timer.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\tree.hpp">
+			</File>
+			<File
+				RelativePath="..\src\pj++\types.hpp">
+			</File>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: pjproject/main/pjlib/build/pjlib.dsp
===================================================================
--- pjproject/main/pjlib/build/pjlib.dsp	(revision 35)
+++ pjproject/main/pjlib/build/pjlib.dsp	(revision 36)
@@ -235,4 +235,11 @@
 
 SOURCE=..\src\pj\ioqueue_winnt.c
+
+!IF  "$(CFG)" == "pjlib - Win32 Release"
+
+!ELSEIF  "$(CFG)" == "pjlib - Win32 Debug"
+
+!ENDIF 
+
 # End Source File
 # Begin Source File
Index: pjproject/main/pjlib/build/pjlib.dsw
===================================================================
--- pjproject/main/pjlib/build/pjlib.dsw	(revision 35)
+++ pjproject/main/pjlib/build/pjlib.dsw	(revision 36)
@@ -4,12 +4,8 @@
 ###############################################################################
 
-Project: "pjlib"=".\pjlib.dsp" - Package Owner=<4>
+Project: "pjlib"=.\pjlib.dsp - Package Owner=<4>
 
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject-0.3/pjlib/build", EJDAAAAA
-    .
-    end source code control
 }}}
 
@@ -20,12 +16,20 @@
 ###############################################################################
 
-Project: "pjlib_samples"=".\pjlib_samples.dsp" - Package Owner=<4>
+Project: "pjlib++"=".\pjlib++.dsp" - Package Owner=<4>
 
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject-0.3/pjlib/build", EJDAAAAA
-    .
-    end source code control
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Project: "pjlib_samples"=.\pjlib_samples.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
 }}}
 
@@ -39,12 +43,8 @@
 ###############################################################################
 
-Project: "pjlib_test"=".\pjlib_test.dsp" - Package Owner=<4>
+Project: "pjlib_test"=.\pjlib_test.dsp - Package Owner=<4>
 
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject-0.3/pjlib/build", EJDAAAAA
-    .
-    end source code control
 }}}
 
@@ -58,16 +58,18 @@
 ###############################################################################
 
-Project: "pjlibpp"=".\pjlibpp.dsp" - Package Owner=<4>
+Project: "pjlib++_test"=.\pjlib++-test.dsp - Package Owner=<4>
 
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject-0.3/pjlib/build", EJDAAAAA
-    .
-    end source code control
 }}}
 
 Package=<4>
 {{{
+    Begin Project Dependency
+    Project_Dep_Name pjlib
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjlib++
+    End Project Dependency
 }}}
 
@@ -78,8 +80,4 @@
 Package=<5>
 {{{
-    begin source code control
-    "$/pjproject-0.3/pjlib/build", EJDAAAAA
-    .
-    end source code control
 }}}
 
Index: pjproject/main/pjlib/include/pj++/file.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/file.hpp	(revision 36)
+++ pjproject/main/pjlib/include/pj++/file.hpp	(revision 36)
@@ -0,0 +1,171 @@
+/* $Id$ */
+
+#ifndef __PJPP_FILE_HPP__
+#define __PJPP_FILE_HPP__
+
+#include <pj/file_io.h>
+#include <pj/file_access.h>
+#include <pj++/types.hpp>
+#include <pj++/pool.hpp>
+
+//
+// File API.
+//
+class Pj_File_API
+{
+public:
+    //
+    // Check file existance.
+    //
+    static bool file_exists(const char *filename)
+    {
+        return pj_file_exists(filename) != 0;
+    }
+
+    //
+    // Get file size.
+    //
+    static pj_off_t file_size(const char *filename)
+    {
+        return pj_file_size(filename);
+    }
+
+    //
+    // Delete file.
+    //
+    static pj_status_t file_delete(const char *filename)
+    {
+        return pj_file_delete(filename);
+    }
+
+    //
+    // Move/rename file.
+    //
+    static pj_status_t file_move(const char *oldname, const char *newname)
+    {
+        return pj_file_move(oldname, newname);
+    }
+
+    //
+    // Get stat.
+    //
+    static pj_status_t file_stat(const char *filename, pj_file_stat *buf)
+    {
+        return pj_file_getstat(filename, buf);
+    }
+};
+
+
+//
+// File.
+//
+class Pj_File : public Pj_Object
+{
+public:
+    //
+    // Offset type to be used in setpos.
+    //
+    enum Offset_Type
+    {
+        SEEK_SET = PJ_SEEK_SET,
+        SEEK_CUR = PJ_SEEK_CUR,
+        SEEK_END = PJ_SEEK_END,
+    };
+
+    //
+    // Default constructor.
+    //
+    Pj_File()
+        : hnd_(0)
+    {
+    }
+
+    //
+    // Construct and open a file.
+    //
+    Pj_File(Pj_Pool *pool, const char *filename,
+            unsigned access = PJ_O_RDONLY)
+    : hnd_(NULL)
+    {
+        open(pool, filename, access);
+    }
+
+    //
+    // Destructor closes the file.
+    //
+    ~Pj_File()
+    {
+        close();
+    }
+
+    //
+    // Open a file.
+    //
+    pj_status_t open(Pj_Pool *pool, const char *filename, 
+                     unsigned access = PJ_O_RDONLY )
+    {
+        close();
+        return pj_file_open(pool->pool_(), filename, access, &hnd_);
+    }
+
+    //
+    // Close a file.
+    //
+    void close()
+    {
+        if (hnd_ != 0) {
+            pj_file_close(hnd_);
+            hnd_ = 0;
+        }
+    }
+
+    //
+    // Write data.
+    //
+    pj_ssize_t write(const void *buff, pj_size_t size)
+    {
+        pj_ssize_t bytes = size;
+        if (pj_file_write(hnd_, buff, &bytes) != PJ_SUCCESS)
+            return -1;
+        return bytes;
+    }
+
+    //
+    // Read data.
+    //
+    pj_ssize_t read(void *buf, pj_size_t size)
+    {
+        pj_ssize_t bytes = size;
+        if (pj_file_read(hnd_, buf, &bytes) != PJ_SUCCESS)
+            return -1;
+        return bytes;
+    }
+
+    //
+    // Set file position.
+    //
+    pj_status_t setpos(pj_off_t offset, Offset_Type whence)
+    {
+        return pj_file_setpos(hnd_, offset, 
+                              (enum pj_file_seek_type)whence);
+    }
+
+    //
+    // Get file position.
+    //
+    pj_off_t getpos()
+    {
+        pj_off_t pos;
+        if (pj_file_getpos(hnd_, &pos) != PJ_SUCCESS)
+            return -1;
+        return pos;
+    }
+
+private:
+    pj_oshandle_t hnd_;
+};
+
+
+
+#endif  /* __PJPP_FILE_HPP__ */
+
Index: pjproject/main/pjlib/include/pj++/hash.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/hash.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/hash.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_HASH_H__
@@ -6,18 +5,43 @@
 
 #include <pj++/types.hpp>
+#include <pj++/pool.hpp>
 #include <pj/hash.h>
 
-class PJ_Hash_Table
+//
+// Hash table.
+//
+class Pj_Hash_Table : public Pj_Object
 {
 public:
+    //
+    // Hash table iterator.
+    //
     class iterator
     {
     public:
-	iterator() {}
-	explicit iterator(pj_hash_table_t *h, pj_hash_iterator_t *i) : ht_(h), it_(i) {}
-	iterator(const iterator &rhs) : ht_(rhs.ht_), it_(rhs.it_) {}
-	void operator++() { it_ = pj_hash_next(ht_, it_); }
-	bool operator==(const iterator &rhs) { return ht_ == rhs.ht_ && it_ == rhs.it_; }
-	iterator & operator=(const iterator &rhs) { ht_=rhs.ht_; it_=rhs.it_; return *this; }
+	iterator() 
+        {
+        }
+	explicit iterator(pj_hash_table_t *h, pj_hash_iterator_t *i) 
+        : ht_(h), it_(i) 
+        {
+        }
+	iterator(const iterator &rhs) 
+        : ht_(rhs.ht_), it_(rhs.it_) 
+        {
+        }
+	void operator++() 
+        { 
+            it_ = pj_hash_next(ht_, it_); 
+        }
+	bool operator==(const iterator &rhs) 
+        { 
+            return ht_ == rhs.ht_ && it_ == rhs.it_; 
+        }
+	iterator & operator=(const iterator &rhs) 
+        { 
+            ht_=rhs.ht_; it_=rhs.it_; 
+            return *this; 
+        }
     private:
 	pj_hash_table_t *ht_;
@@ -25,49 +49,91 @@
 	pj_hash_iterator_t *it_;
 
-	friend class PJ_Hash_Table;
+	friend class Pj_Hash_Table;
     };
 
-    static PJ_Hash_Table *create(PJ_Pool *pool, unsigned size)
+    //
+    // Construct hash table.
+    //
+    Pj_Hash_Table(Pj_Pool *pool, unsigned size)
     {
-	return (PJ_Hash_Table*) pj_hash_create(pool->pool_(), size);
+	table_ = pj_hash_create(pool->pool_(), size);
     }
 
-    static pj_uint32_t calc(pj_uint32_t initial_hval, const void *key, unsigned keylen)
+    //
+    // Destroy hash table.
+    //
+    ~Pj_Hash_Table()
+    {
+    }
+
+    //
+    // Calculate hash value.
+    //
+    static pj_uint32_t calc( pj_uint32_t initial_hval, 
+                             const void *key, 
+                             unsigned keylen = PJ_HASH_KEY_STRING)
     {
 	return pj_hash_calc(initial_hval, key, keylen);
     }
 
-    pj_hash_table_t *hash_table_()
+    //
+    // Return pjlib compatible hash table object.
+    //
+    pj_hash_table_t *pj_hash_table_t_()
     {
-	return (pj_hash_table_t*)this;
+	return table_;
     }
 
-    void *get(const void *key, unsigned keylen)
+    //
+    // Get the value associated with the specified key.
+    //
+    void *get(const void *key, unsigned keylen = PJ_HASH_KEY_STRING)
     {
-	return pj_hash_get(this->hash_table_(), key, keylen);
+	return pj_hash_get(table_, key, keylen);
     }
 
-    void set(PJ_Pool *pool, const void *key, unsigned keylen, void *value)
+    //
+    // Associate a value with a key.
+    // Set the value to NULL to delete the key from the hash table.
+    //
+    void set(Pj_Pool *pool, 
+             const void *key, 
+             void *value,
+             unsigned keylen = PJ_HASH_KEY_STRING)
     {
-	pj_hash_set(pool->pool_(), this->hash_table_(), key, keylen, value);
+	pj_hash_set(pool->pool_(), table_, key, keylen, value);
     }
 
+    //
+    // Get number of items in the hash table.
+    //
     unsigned count()
     {
-	return pj_hash_count(this->hash_table_());
+	return pj_hash_count(table_);
     }
 
+    //
+    // Iterate hash table.
+    //
     iterator begin()
     {
-	iterator it(this->hash_table_(), NULL);
-	it.it_ = pj_hash_first(this->hash_table_(), &it.it_val_);
+	iterator it(table_, NULL);
+	it.it_ = pj_hash_first(table_, &it.it_val_);
 	return it;
     }
 
+    //
+    // End of items.
+    //
     iterator end()
     {
-	return iterator(this->hash_table_(), NULL);
+	return iterator(table_, NULL);
     }
+
+private:
+    pj_hash_table_t *table_;
 };
 
+
 #endif	/* __PJPP_HASH_H__ */
+
Index: pjproject/main/pjlib/include/pj++/list.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/list.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/list.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_LIST_H__
@@ -6,46 +5,107 @@
 
 #include <pj/list.h>
-
-template <typename T>
-struct PJ_List_Node
-{
-    PJ_DECL_LIST_MEMBER(T)
-};
-
-
-template <class Node>
-class PJ_List
+#include <pj++/pool.hpp>
+
+
+//
+// Linked-list.
+//
+// Note:
+//  List_Node must have public member next and prev. Normally
+//  it will be declared like:
+//
+//  struct my_node
+//  {
+//      PJ_DECL_LIST_MEMBER(struct my_node);
+//      ..
+//  };
+//
+//
+template <class List_Node>
+class Pj_List : public Pj_Object
 {
 public:
-    PJ_List() { pj_list_init(&root_); if (0) compiletest(); }
-    ~PJ_List() {}
-
+    //
+    // List const_iterator.
+    //
     class const_iterator
     {
     public:
-	const_iterator() : node_(NULL) {}
-	const_iterator(const Node *nd) : node_((Node*)nd) {}
-	const Node * operator *() { return node_; }
-	const Node * operator -> () { return node_; }
-	const_iterator operator++() { return const_iterator(node_->next); }
-	bool operator==(const const_iterator &rhs) { return node_ == rhs.node_; }
-	bool operator!=(const const_iterator &rhs) { return node_ != rhs.node_; }
+	const_iterator() 
+            : node_(NULL) 
+        {}
+	const_iterator(const List_Node *nd) 
+            : node_((List_Node*)nd) 
+        {}
+	const List_Node * operator *() 
+        { 
+            return node_; 
+        }
+	const List_Node * operator -> () 
+        { 
+            return node_; 
+        }
+	const_iterator operator++() 
+        { 
+            return const_iterator(node_->next); 
+        }
+	bool operator==(const const_iterator &rhs) 
+        { 
+            return node_ == rhs.node_; 
+        }
+	bool operator!=(const const_iterator &rhs) 
+        { 
+            return node_ != rhs.node_; 
+        }
 
     protected:
-	Node *node_;
+	List_Node *node_;
     };
 
+    //
+    // List iterator.
+    //
     class iterator : public const_iterator
     {
     public:
-	iterator() {}
-	iterator(Node *nd) : const_iterator(nd) {}
-	Node * operator *() { return node_; }
-	Node * operator -> () { return node_; }
-	iterator operator++() { return iterator(node_->next); }
-	bool operator==(const iterator &rhs) { return node_ == rhs.node_; }
-	bool operator!=(const iterator &rhs) { return node_ != rhs.node_; }
+	iterator() 
+        {}
+	iterator(List_Node *nd) 
+            : const_iterator(nd) 
+        {}
+	List_Node * operator *() 
+        { 
+            return node_; 
+        }
+	List_Node * operator -> () 
+        { 
+            return node_; 
+        }
+	iterator operator++() 
+        { 
+            return iterator(node_->next); 
+        }
+	bool operator==(const iterator &rhs) 
+        { 
+            return node_ == rhs.node_; 
+        }
+	bool operator!=(const iterator &rhs) 
+        { 
+            return node_ != rhs.node_; 
+        }
     };
 
+    //
+    // Default constructor.
+    //
+    Pj_List() 
+    { 
+        pj_list_init(&root_); 
+        if (0) compiletest(); 
+    }
+
+    //
+    // Check if list is empty.
+    // 
     bool empty() const
     {
@@ -53,4 +113,7 @@
     }
 
+    //
+    // Get first element.
+    //
     iterator begin()
     {
@@ -58,4 +121,7 @@
     }
 
+    //
+    // Get first element.
+    //
     const_iterator begin() const
     {
@@ -63,44 +129,71 @@
     }
 
+    //
+    // Get end-of-element
+    //
     const_iterator end() const
     {
-	return const_iterator((Node*)&root_);
-    }
-
+	return const_iterator((List_Node*)&root_);
+    }
+
+    //
+    // Get end-of-element
+    //
     iterator end()
     {
-	return iterator((Node*)&root_);
-    }
-
-    void insert_before (iterator &pos, Node *node)
+	return iterator((List_Node*)&root_);
+    }
+
+    //
+    // Insert node.
+    //
+    void insert_before (iterator &pos, List_Node *node)
     {
 	pj_list_insert_before( *pos, node );
     }
 
-    void insert_after(iterator &pos, Node *node)
+    //
+    // Insert node.
+    //
+    void insert_after(iterator &pos, List_Node *node)
     {
 	pj_list_insert_after(*pos, node);
     }
 
-    void merge_first(Node *list2)
+    //
+    // Merge list.
+    //
+    void merge_first(List_Node *list2)
     {
 	pj_list_merge_first(&root_, list2);
     }
 
-    void merge_last(PJ_List *list)
+    //
+    // Merge list.
+    //
+    void merge_last(Pj_List *list)
     {
 	pj_list_merge_last(&root_, &list->root_);
     }
 
-    void insert_nodes_before(iterator &pos, PJ_List *list2)
+    //
+    // Insert list.
+    //
+    void insert_nodes_before(iterator &pos, Pj_List *list2)
     {
 	pj_list_insert_nodes_before(*pos, &list2->root_);
     }
 
-    void insert_nodes_after(iterator &pos, PJ_List *list2)
+    //
+    // Insert list.
+    //
+    void insert_nodes_after(iterator &pos, Pj_List *list2)
     {
 	pj_list_insert_nodes_after(*pos, &list2->root_);
     }
 
+    //
+    // Erase an element.
+    //
     void erase(iterator &it)
     {
@@ -108,14 +201,23 @@
     }
 
-    Node *front()
+    //
+    // Get first element.
+    //
+    List_Node *front()
     {
 	return root_.next;
     }
 
-    const Node *front() const
+    //
+    // Get first element.
+    //
+    const List_Node *front() const
     {
 	return root_.next;
     }
 
+    //
+    // Remove first element.
+    //
     void pop_front()
     {
@@ -123,14 +225,23 @@
     }
 
-    Node *back()
+    //
+    // Get last element.
+    //
+    List_Node *back()
     {
 	return root_.prev;
     }
 
-    const Node *back() const
+    //
+    // Get last element.
+    //
+    const List_Node *back() const
     {
 	return root_.prev;
     }
 
+    //
+    // Remove last element.
+    //
     void pop_back()
     {
@@ -138,26 +249,41 @@
     }
 
-    iterator find(Node *node)
-    {
-	Node *n = pj_list_find_node(&root_, node);
+    //
+    // Find a node.
+    //
+    iterator find(List_Node *node)
+    {
+	List_Node *n = pj_list_find_node(&root_, node);
 	return n ? iterator(n) : end();
     }
 
-    const_iterator find(Node *node) const
-    {
-	Node *n = pj_list_find_node(&root_, node);
+    //
+    // Find a node.
+    //
+    const_iterator find(List_Node *node) const
+    {
+	List_Node *n = pj_list_find_node(&root_, node);
 	return n ? const_iterator(n) : end();
     }
 
-    void push_back(Node *node)
+    //
+    // Insert a node in the back.
+    //
+    void push_back(List_Node *node)
     {
 	pj_list_insert_after(root_.prev, node);
     }
 
-    void push_front(Node *node)
+    //
+    // Insert a node in the front.
+    //
+    void push_front(List_Node *node)
     {
 	pj_list_insert_before(root_.next, node);
     }
 
+    //
+    // Remove all elements.
+    //
     void clear()
     {
@@ -169,5 +295,5 @@
     struct RootNode
     {
-	PJ_DECL_LIST_MEMBER(Node)
+	PJ_DECL_LIST_MEMBER(List_Node);
     } root_;
 
@@ -175,6 +301,6 @@
     {
 	// If you see error in this line, 
-	// it's because Node is not derived from PJ_List_Node.
-	Node *n = (Node*)0;
+	// it's because List_Node is not derived from Pj_List_Node.
+	List_Node *n = (List_Node*)0;
 	n = n->next; n = n->prev;
     }
Index: pjproject/main/pjlib/include/pj++/lock.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/lock.hpp	(revision 36)
+++ pjproject/main/pjlib/include/pj++/lock.hpp	(revision 36)
@@ -0,0 +1,131 @@
+/* $Id$ */
+#ifndef __PJPP_LOCK_H__
+#define __PJPP_LOCK_H__
+
+#include <pj++/types.hpp>
+#include <pj/lock.h>
+#include <pj++/pool.hpp>
+
+//////////////////////////////////////////////////////////////////////////////
+// Lock object.
+//
+class Pj_Lock : public Pj_Object
+{
+public:
+    //
+    // Constructor.
+    //
+    explicit Pj_Lock(pj_lock_t *lock)
+        : lock_(lock)
+    {
+    }
+
+    //
+    // Destructor.
+    //
+    ~Pj_Lock()
+    {
+        if (lock_)
+            pj_lock_destroy(lock_);
+    }
+
+    //
+    // Get pjlib compatible lock object.
+    //
+    pj_lock_t *pj_lock_t_()
+    {
+        return lock_;
+    }
+
+    //
+    // acquire lock.
+    //
+    pj_status_t acquire()
+    {
+        return pj_lock_acquire(lock_);
+    }
+
+    //
+    // release lock,.
+    //
+    pj_status_t release()
+    {
+        return pj_lock_release(lock_);
+    }
+
+protected:
+    pj_lock_t *lock_;
+};
+
+
+//////////////////////////////////////////////////////////////////////////////
+// Null lock object.
+//
+class Pj_Null_Lock : public Pj_Lock
+{
+public:
+    //
+    // Default constructor.
+    //
+    explicit Pj_Null_Lock(Pj_Pool *pool, const char *name = NULL)
+        : Pj_Lock(NULL)
+    {
+        pj_lock_create_null_mutex(pool->pool_(), name, &lock_);
+    }
+};
+
+//////////////////////////////////////////////////////////////////////////////
+// Simple mutex lock object.
+//
+class Pj_Simple_Mutex_Lock : public Pj_Lock
+{
+public:
+    //
+    // Default constructor.
+    //
+    explicit Pj_Simple_Mutex_Lock(Pj_Pool *pool, const char *name = NULL)
+        : Pj_Lock(NULL)
+    {
+        pj_lock_create_simple_mutex(pool->pool_(), name, &lock_);
+    }
+};
+
+//////////////////////////////////////////////////////////////////////////////
+// Recursive mutex lock object.
+//
+class Pj_Recursive_Mutex_Lock : public Pj_Lock
+{
+public:
+    //
+    // Default constructor.
+    //
+    explicit Pj_Recursive_Mutex_Lock(Pj_Pool *pool, const char *name = NULL)
+        : Pj_Lock(NULL)
+    {
+        pj_lock_create_recursive_mutex(pool->pool_(), name, &lock_);
+    }
+};
+
+//////////////////////////////////////////////////////////////////////////////
+// Semaphore lock object.
+//
+class Pj_Semaphore_Lock : public Pj_Lock
+{
+public:
+    //
+    // Default constructor.
+    //
+    explicit Pj_Semaphore_Lock(Pj_Pool *pool, 
+                               unsigned max=PJ_MAXINT32,
+                               unsigned initial=0,
+                               const char *name=NULL)
+        : Pj_Lock(NULL)
+    {
+        pj_lock_create_semaphore(pool->pool_(), name, initial, max, &lock_);
+    }
+};
+
+
+
+#endif	/* __PJPP_LOCK_H__ */
+
